<?php
  define ("SDA_VALIDENTRY",1);
  require_once("common.php");
  require_once("inc_parser.php");

//  $start=$start_0=microtime(1);
  sda_prof_begin("generate_flash_playlist execution");

  if (!isset($_GET['rid'])) {
    sda_die("[1]");
  }
  if (!is_numeric($_GET['rid'])) {
    sda_die("[2]");
  }
  $rid=(integer)$_GET['rid'];

  if (!isset($_GET['mid'])) {
    sda_die("[7]");
  }
  if (!is_numeric($_GET['mid'])) {
    sda_die("[8]");
  }
  $mid=(integer)$_GET['mid'];
  if ($mid===SDA_MIRROR_ID_ARCHIVE) {
    if (!isset($_GET['use_backup'])||
        !is_numeric($_GET['use_backup'])||
        ($_GET['use_backup']!="0"&&$_GET['use_backup']!="1")) {
      sda_die ("[10]");
    }
    $use_backup=(integer)$_GET['use_backup'];
  }
/*
  $q="select * from v_run_categories where run_id=".$rid;
  $r=sda_rquery($q);
  //$cats=array();
  $cats_concat="";
  foreach ($r as $ix=>$row) {
    if ($cats_concat!="") { $cats_concat.=", "; }
    $cat=category_from_db_row($row);
    $cats_concat.=$cat->cat_desc_en_us_short;
  }
*/
  sda_prof_begin("sda_get_parts_split");
  if (FALSE===($parts=sda_get_parts_split($rid,0))) { // 0 = get the parts, don't just count them
    sda_die("[3]");
  }
  sda_prof_end("sda_get_parts_split");
  sda_prof_begin("sda_get_vidfiles");
  if (FALSE===($vidfiles=sda_get_vidfiles($rid,1,1))) { // flash only, key by part
    sda_die("[4]");
  }
  sda_prof_end("sda_get_vidfiles");
  sda_prof_begin("sda_get_mirrors_2");
  if (FALSE===($mirrors_fk=sda_get_mirrors_2($rid,SDA_FLAVOUR_FIRST))) { // load all the mirrors, not just $mid ... we may need spares
    sda_die("[5]");
  }
  sda_prof_end("sda_get_mirrors_2");
//print "count($mirrors_fk)=".count($mirrors_fk)."<br>";
  if (!isset($mirrors_fk[SDA_FLAVOUR_ID_FLASH][$mid])) {
    sda_die("[9]");
  }
  $c=count($parts[SDA_IX_MAIN_PARTS]);
  sda_prof_begin("sda_build_vidfile_links_2");
  if (FALSE===($links=sda_build_vidfile_links_2($mirrors_fk, $vidfiles, $c))) {
    sda_die("[6]");
  }
  sda_prof_end("sda_build_vidfile_links_2");

  // get IL level for run, if run is IL.
  //$q="select * from v_il_run_level where run_id=".$rid;
  $q_level="select ".
             "il_run_level.run_id,".
             "il_levels.level_name_1,".
             "il_levels.level_name_2".
           " from ".
             "il_run_level,".
             "il_levels".
           " where ".
             "il_run_level.level_id=il_levels.level_id".
             " and il_run_level.update_id=0".
             " and il_levels.update_id=0".
             " and run_id=".$rid;
  //$r=sda_rquery($q);
  sda_prof_begin("q_level");
  $r_level=sda_mysql_query($q_level);
  sda_prof_end("q_level");
  $is_il=0;
  sda_prof_begin("r_level");
  if (FALSE!==($row_level=mysql_fetch_assoc($r_level))) {
//  if (count($r)) {
    $is_il=1;
    //$r=$r[0];
    $level_name_1=$row_level['level_name_1'];
    $level_name_2=$row_level['level_name_2'];
  }
  sda_prof_end("r_level");
  unset($r);
  
  // bit of a hack -- remove non-flash entries from mirrors list
  // this used to be done by a parametric call to sda_get_mirrors(), and
  // perhaps this functionality should go back in, but for now ...
  foreach ($mirrors_fk as $fid=>$mirrors_array) {
    if ($fid!==SDA_FLAVOUR_ID_FLASH) { unset($mirrors_fk[$fid]); }
  }

  $playlist_escaped="";
  sda_prof_begin("build flash playlist");
  foreach ($parts[SDA_IX_MAIN_PARTS] as $k=>$v) {
    $playlist_escaped.="  <track>\n   <title>";
    $vf=$vidfiles[$v['part_id']];
    //if (!$vf->run_is_il) {
    if (!$is_il) {
      $pn=sda_part_name($c,$v['name'],$v['part']);
      if (isset($v['description']) && $v['description']!="") {
        $pn.=(" — ".$v['description']);
      }
    } else {
      // IL ...
      // need category data, level name etc.
      //$pn=$cats_concat;
      $pn=$level_name_1;
      if (isset($level_name_2) && $level_name_2 != "") { $pn.=" - ".$level_name_2; }
    }
    $playlist_escaped.=sda_xmlentities($pn);
    $playlist_escaped.="</title>\n";
    //$vf=$vidfiles[$v['part_id']];
    // try to get the preferred mirror
    $preferred=NULL;
//if (isset($links[SDA_FLAVOUR_ID_FLASH][$v['part_id']])) {
    $mlist=$links[SDA_IX_MAIN_PARTS][SDA_FLAVOUR_ID_FLASH][$v['part_id']];
//} else { // 
//}
    if (isset($mlist[$mid])) {
      foreach ($mlist[$mid] as $k2=>$v2) {
        // not archive ... just take the first one (there should only be one !)
        if ($mid!=SDA_MIRROR_ID_ARCHIVE) {
          $preferred=$v2; break;
        }
        // If an archive server is overridden, there will only be one
        // link object, so this loop will only execute once. There may also
        // only be one archive server link object depending on the backup mode setting.
        // So, if a preference for archive has been expressed and there's only
        // one archive server available for whatever reason, use it (i.e. the first one) ...
        if (count($mlist[$mid])===1) {
          $preferred=$v2; break;
        }
        // otherwise, loop until the criteria match exactly.
        if ((!($v2->archive_backup XOR $use_backup))) { // XNOR
          $preferred=$v2; break;
        }
      }
    }
    if ($preferred===NULL) {
      // no luck. OK, pick one at random.
      // (FIXME: This algorithm is broken.)
      if (!count($mlist)) { die ("[11] (dbz)"); }
      $r=rand()%count($mlist);
      $i=0;
      foreach ($mlist as $k2=>$v2) {
        if (!count($v2)) { continue; } // hack
        $womg=$v2;
        if ($i===$r) { break; }
        $i++;
      }
      if (isset($womg)) {
        $r=rand()%count($womg);
        $preferred=$womg[$r];
      }
    }
    if ($preferred!==NULL) {
      $playlist_escaped.="   <location>";
      $playlist_escaped.=sda_xmlentities($preferred->url);
      $playlist_escaped.="</location>\n";
    }
    $playlist_escaped.="  </track>\n";
  }
  sda_prof_end("build flash playlist");




  //header('Content-type: application/xspf+xml');

  print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  print "<playlist version=\"1\" xmlns=\"http://xspf.org/ns/0/\">\n";
  print " <info>http://speeddemosarchive.com/</info>\n";
  // these don't seem to do anything, so I can't be bothered writing stuff to extract them from the DB:
//  print " <title></title>\n";
//  print " <creator></creator>\n";
  print " <trackList>\n";
  print $playlist_escaped;
  print " </trackList>\n";
  print "</playlist>";
  
  sda_prof_end("generate_flash_playlist execution");
  
  
